Subject: RE: Help - Naming problems in SLP 'service:printer'

From: "Hugo Parra" <[email-masked]>
Date: Thu, 02 Mar 2000 10:59:04 -0700

I've added a few comments below.
-Hugo

>>> "McDonald, Ira" <[email-masked]> 03/02/00 10:19AM >>>
> [Sorry for earlier empty reply - sticky mouse]
>
> Hi Paul,
>
> We could certainly use 'collection' to hold the values in
> 'application/ipp' encoding (that is, the URI and zero
> or more of their associated metaparameters for security,
> authentication, etc.).

Tom is right in saying that the decision of how to represent this information in SLP and LDAP can be  made independently of how we choose to represent it in IPP.  And I think we're converging on Ira's proposal for the SLP and LDAP representation.

Except ... there's real urgency in fixing the IPP definition now given the impending publication of the Set-Printer-Attribute operation.  Fixing the IPP definitions for these parallel attributes will be much harder after the "Set" operation is out (unless the current attribute threesome is marked as "Read-Only" in the spec with a note that a standard way for setting those attributes will be available in the future).

>
> But in SLP, LDAP, and a lot of other directory interfaces,
> we need a simple string encoding (see the Subject of
> this message).
>
> In the SLP and LDAP encoding of the three original
> parallel attributes, we already use the '>' (greater
> than) as the URL delimiter (per RFC 2396 and advice
> from Larry Masinter).
>
> If we use 'collection' syntax in 'application/ipp',
> the new combined attribute (now a collection) won't
> be accessible to IPP/1.0 and IPP/1.1 existing software
> (some of which IS extensible for new attributes with
> simple datatypes).

By pre-fixing collection attribute names we achieve the same level of interoperability with existing IPP clients as the one you imply.  Namely, the reading of a semantically opaque attributes with a known syntax.  Notice that IPP clients from the beginning have been advised to skip over unknown attribute syntaxes.  Current clients will have no harder time ignoring the 'start-of-collection' and 'end-of-collection' delimiters than ignoring the new 'xri' syntax.

Again, we don't have to worry about current clients being able to set the new collection syntax because the "Set" operation is not out yet.  Hence the time-sensitive nature of making this decision real soon. 

> Thus, I was thinking of simple
> multi-valued strings (an actual new 'xri' syntax isn't
> strictly necessary for the IPP encoding), for better
> interworking.
>
> Cheers,
> - Ira McDonald
>